<?php
/***************************************************************************
 *                              attachments.php
 *                            -------------------
 *   begin                : Saturday, Apr 6, 2002
 *   copyright            : (C) 2002 Matthijs van de Water
 *   email                : matthijs@beryllium.net
 *
 *   $Id: attachments.php,v 1.00 2002/04/06 16:00:00 mvdwater Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

/***************************************************************************
 *
 * VBULLETIN 2.x CONVERSION TOOL ADDON FOR ATTACHMENTS
 *
 *  For use with the Attachment MOD by Acyd Burn
 *  See contrib dir of your phpBB installation for details
 *  Attachment MOD must be installed before proceeding
 *
 ***************************************************************************/

// NOTE: BE SURE TO PROTECT YOU ATTACHMENTS DIR FROM DIRECT READING!
// THIS IS BETA SOFTWARE, IF YOU FIND ANY BUGS, PLEASE REPORT THEM IN THE
// PHPBB FORUMS IN THE APPROPRIATE TOPIC

// vBulletin path (relative to this file)
define('VBULLETIN_PATH', './');

// phpBB path (relative to this file)
define('PHPBB_PATH', '../phpBB2/');

// should existing attachments be deleted from the database?
// 1 or 0
define('DELETE_EXISTING', 0);

//
// Attachment MOD filetypes
// Add any filetypes you are using on your server that are not
// listed below.
// If you introduce a new mimetype, you should not forget to
// add it to the attachment configuration in the admin panel
// after the conversion is done. The affected attachments won't
// be accessible before you do so!
// The script will check if the vB allowed extensions are all
// defined below before starting the process.
//
// Syntax: 'extension' => 'mimetype',
//
$attachment_extensions = array (
	'jpg' => 'image/jpeg',
	'jpeg' => 'image/jpeg',
	
	'gif' => 'image/gif',
	
	'png' => 'image/png',
	
	'txt' => 'text/plain',
	'asc' => 'text/plain',
	'nfo' => 'text/plain',
	'sql' => 'text/plain',
	'phps' => 'text/plain',
	'php' => 'text/plain',
	'php3' => 'text/plain',
	'php4' => 'text/plain',
	'phtml' => 'text/plain',
	'asp' => 'text/plain',
	'html' => 'text/plain',
	'htm' => 'text/plain',
	'css' => 'text/plain',
	'js' => 'text/plain',
	'xml' => 'text/plain',
	'xls' => 'text/plain',
	'cgi' => 'text/plain',
	'pl' => 'text/plain',
	'phtml' => 'text/plain',
	'inc' => 'text/plain',
	'tpl' => 'text/plain',
	'c' => 'text/plain',
	'cc' => 'text/plain',
	'h' => 'text/plain',
	'hh' => 'text/plain',
	'cpp' => 'text/plain',
	'hpp' => 'text/plain',
	
	'pdf' => 'application/pdf',

	'doc' => 'application/msword',
	'dot' => 'application/msword',

	'ppt' => 'application/powerpoint',
	
	'xls' => 'application/excel',
	
	'ps' => 'application/postscript',
	'ai' => 'application/postscript',
	'eps' => 'application/postscript',
	
	'zip' => 'application/x-zip-compressed',
	
	'gz' => 'application/x-gzip-compressed',
	
	'tar' => 'application/x-tar',
	
	'tgz' => 'application/x-gtar'
);
//
// End configuration
//

//
// No need to change anything below this line
//

// Check if paths defined above are correct
if ( !@file_exists(VBULLETIN_PATH . 'admin/config.php') )
{
	die("ERROR: Unable to find vBulletin configuration file.<br />Check the path defines.<br />");
}
if ( !@file_exists(PHPBB_PATH . 'extension.inc') )
{
	die("ERROR: Unable to find phpBB includes.<br />Check the path defines.<br />");
}

//
// Unlimited execution time
//
@set_time_limit(0);

//
// Initialize vBulletin database class
//

// Load config file
require(VBULLETIN_PATH . 'admin/config.php');

// Force persistent connections
$usepconnect = 1;

// Init DB class, force MySQL
require(VBULLETIN_PATH . 'admin/db_mysql.php');

$DB_site = new DB_Sql_vb();

$DB_site->database = $dbname;
$DB_site->server = $servername;
$DB_site->user = $dbusername;
$DB_site->password = $dbpassword;

// Use our own error reporting
$DB_site->reporterror = 0;

$DB_site->connect();

// Load vBulletin options
$sql = "SELECT template AS options FROM template WHERE title='options'";
$options_query = $DB_site->query($sql);
if ( !$options_query )
{
	die("Unable to fetch vBulletin options");
}
$row = $DB_site->fetch_array($options_query);
eval($row['options']);

$DB_site->free_result($options_query);
unset($row);

if ( !$templateversion )
{
	$templateversion = '2.0.0';
}
define('VBULLETIN_VERSION', $templateversion);

//
// Include phpBB config and global files and needed functions
//
define('IN_PHPBB', 1);
$phpbb_root_path = PHPBB_PATH;
include(PHPBB_PATH . 'extension.inc');
include(PHPBB_PATH . 'common.' . $phpEx);

//
// Check if attachment MOD is installed
//
if ( !@file_exists(PHPBB_PATH . 'attachment_mod' . $phpEx) )
{
	die('Attachment MOD not installed or incorrect path defined.');
}

else
{
	$extensions = explode(" ", $attachextensions);
	$not_found = false;
	while ( list($i, $ext) = each($extensions) )
	{
		$ext = trim($ext);
		if ( !empty($ext) )
		{
			if ( !$attachment_extensions[$ext] )
			{
				$exts[] = $ext;
				$not_found = true;
			}
		}
	}
	if ( $not_found == true )
	{
			$extensions = implode(" .", $exts);
			print "<b>ERROR</b> :: Unknown filetype(s) found (.$extensions).<br />You should edit the attachment_extensions array in de config settings of this script to be able to continue. You may need to add any new mimetype you introduce in the attachments admin panel after the Conversion is completed.<br />";
			print "Reload this page after you edited the script.<br />";
			exit;
	}

	//
	// Get dir for attachments
	//
	$sql = "SELECT config_value FROM " . ATTACH_CONFIG_TABLE . " WHERE config_name='upload_dir'";
	$dir_query = $db->sql_query($sql);
	if ( !$dir_query )
	{
		die("Unable to query attachment upload dir.<br />$sql");
	}

	$row = $db->sql_fetchrow($dir_query);
	$attachment_dir = PHPBB_PATH . $row['config_value'];

	if ( !@is_writable($attachment_dir . '/') )
	{
		// Attachment dir not writable
		print "<b>ERROR</b> :: Attachments dir ($attachment_dir) is not writable.<br />You should CHMOD the attachment dir to 777 and reload this page.<br />";
		exit;
	}

	if ( DELETE_EXISTING == 1 )
	{
		print "* Deleting existing attachment information from database :: ";
		$result = $db->sql_query("DELETE FROM " . ATTACH_DESC_TABLE );
		if ( !$result )
		{
			die("Unable to delete exisiting attachments");
		}
		print "<b>OK</b><br />\n";
		flush();
	}

	//
	// Update attachment settings
	//
	$queries = array();
	$queries[] = "UPDATE " . ATTACH_CONFIG_TABLE . " SET config_value='$maxattachsize' WHERE config_name='max_filesize'";
	$queries[] = "UPDATE " . ATTACH_CONFIG_TABLE . " SET config_value='$viewattachedimages' WHERE config_name='image_upload'";
	@reset($queries);
	while ( list($i, $sql) = each($queries) )
	{
		$result = $db->sql_query($sql);
		if ( !$result )
		{
			die("Unable to update attachment setting ($i)<br />$sql");
		}
	}
	unset($queries);

	//
	// Do attachments in small batches so server won't overload
	//
	$batchsize = 50;
	$sql = "SELECT MAX(attachmentid) AS max_id FROM attachment";
	$maxid_query = $DB_site->query($sql);
	if ( !$maxid_query )
	{
		die("Unable to fetch maximum attachmentid<br />$sql");
	}
	$row = $DB_site->fetch_array($maxid_query);
	$max_id = $row['max_id'];

	$batchcount = 0;
	$total_percent = 0;
	$error = false;

	for($counter = $start_id; $counter <= $max_id; $counter += $batchsize)
	{
		$batchstart = $counter + 1;
		$batchend = $counter + $batchsize;
		$batchcount++;

		print "* Converting attachments ($batchstart to $batchend) :: ";
		flush();

		$sql = "SELECT a.*, p.postid
						FROM post AS p LEFT JOIN attachment AS a ON p.attachmentid = a.attachmentid
						WHERE a.attachmentid
							BETWEEN $batchstart
								AND $batchend";
		$attach_query = $DB_site->query($sql);
		if ( !$attach_query )
		{
			die("Unable to fetch attachment batch<br />$sql");
		}

		$per_pct = ceil( $DB_site->num_rows($attach_query) / 40 );
		$inc = 0;

		while ( $attachment = $DB_site->fetch_array($attach_query) )
		{

			// Since vB allows for multiple posts linking to the same attachmentid and phpBB doesn't,
			// attachmentids will be lost in the conversion process.
			// Don't think anybody was linking to them directly, but if you are, you're
			// out of luck.
			// Finding the corresponding file after conversion will require some searching
			// in the database for the correct filename.

			$filedata = $attachment['filedata'];
			$filesize = strlen($filedata);
			$ext = strrchr($attachment['filename'], '.');

			// Get mimetype and check it
			$mimetype = $attachment_extensions[$ext];
			if ( empty($mimetype) )
			{
				// Invalid extention, skip this file
				continue;
			}

			// Default naming convention used by author of MOD
			$local_filename = $attachment['userid'] . '_' . $attachment['dateline'] . '.' . $ext;

			// Write attachment to file
			$fp = @fopen($attachment_dir . "/" . $local_filename, "w");
			if ( !$fp )
			{ 
				die("<b>ERROR</b> :: Can't write file $attachment_dir/$local_filename");
			} 
			else
			{ 
				fwrite($fp, $filedata); 
				fclose($fp); 
			}

			$post_id = intval($attachment['postid']);
			$download_count = intval($attachment['counter']);
			$filename = addslashes($attachment['filename']);
			$filetime = intval($attachment['dateline']);

			$sql = "INSERT INTO " . ATTACH_DESC_TABLE . " (post_id, attach_filename, download_count, filename, mimetype, filesize, filetime)
							VALUES ('$post_id', '$local_filename', '$download_count', '$filename', '$mimetype', '$filesize', '$filetime')";
			$result = $db->sql_query($sql);
			if ( !$result )
			{
				die("Unable to insert attachment<br />$sql");
			}

			$inc++;
			if ( $inc == $per_pct )
			{
				print ".";
				flush();
				$inc = 0;
			}
		}

		print "<b>OK</b><br />\n";
	}

}
?>